unit CopieEcranPrg;             //108
                        // Partie d'un programme de Fobec sur developer.com
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, Propos;

CONST
  signature = WM_USER+2000;

type
  TCopieEcranFPrg = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    Propos1: TPropos;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    PROCEDURE InterceptMessageDll(VAR AMsg: TMessage); message signature;
  end;

var
  CopieEcranFPrg: TCopieEcranFPrg;

PROCEDURE InstalDllInterception( AdresseDonnes: HWnd; DllSignature : Integer);
          stdcall; external 'Interception.dll';
PROCEDURE DesinstalDllInterception; stdcall; external 'Interception.dll';

implementation

{$R *.dfm}
VAR
  nom_rep : String;

procedure TCopieEcranFPrg.FormCreate(Sender: TObject);
begin
  nom_rep := ExtractFilePath(Application.ExeName);
  DirectoryListBox1.Directory := nom_rep;
  InstalDllInterception(Handle,signature);
end;

procedure TCopieEcranFPrg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DesinstalDllInterception;
end;

PROCEDURE Copie_Ecran;
VAR
  AdresseBurreau : HDC;
  nom_fichier    : string;
  c_i            : Word;
  EcranBmp       : TBitmap;
BEGIN
  EcranBmp := TBitmap.Create;      // GetDesktopWindow retour le Handle du bureau
  AdresseBurreau := GetDC(GetDesktopWindow); // handle sur un context bureau
  EcranBmp.Width := Screen.Width;
  EcranBmp.Height:= Screen.Height;
  BitBlt(EcranBmp.Canvas.Handle,0,0,Screen.Width,Screen.Height,
         AdresseBurreau,0,0,SrcCopy); // copie bit  bit vers EcranBmp
  ReleaseDC(GetDesktopWindow,AdresseBurreau); // Libere handle contexte bureau
  C_i := 1;
  REPEAT
    IF c_i>9
    THEN nom_fichier := CopieEcranFPrg.DirectoryListBox1.Directory+
                   '\ecran'+IntToStr(c_i)+'.bmp'
    ELSE nom_fichier := CopieEcranFPrg.DirectoryListBox1.Directory+
                   '\ecran0'+IntToStr(c_i)+'.bmp';
    INC(c_i);
  UNTIL NOT(FileExists(nom_fichier));
  EcranBmp.SaveToFile(nom_fichier);
  EcranBmp.Free;
END;

PROCEDURE TCopieEcranFPrg.InterceptMessageDll(VAR AMsg: TMessage);
BEGIN
  AMsg.Result := 0;     // propage le message au autre application
  IF (Amsg.WParam=119) // F8 -> 119
  THEN BEGIN
    WindowState:=wsMinimized; // ferme la fentre
    Hide;
    Sleep(200);
    copie_ecran;
    Show;
  END;
END;

procedure TCopieEcranFPrg.Button1Click(Sender: TObject);
begin
  Propos1.PCaption := 'A propos du Copieur d''cran';
  Propos1.PVersion := ('1.03');
  Propos1.Lignes.Add('Version 1.03 : 2003');
  Propos1.Lignes.Add('  Amlioration du programme de Fobec');
  Propos1.Lignes.Add('    Fortement inspir du tutorial de Michel');
  Propos1.Lignes.Add('    sur les Hook');
  Propos1.Lignes.Add('');
  propos1.Execute;
end;

end.
